<user_asset>
    <style>
        input[type='radio'] {
            width: 20px !important;
        }
        .dt-buttons.insertSpace {
            display: none !important;
        }
    </style>
    <data/>
    <script>
        export default {
            onBeforeMount(props, state) {
                this.scrutiny = props.scrutiny
                this.logoutModal = props.logoutModal
            },
            onMounted(props, states) {
                clearErrorMessage()
                RiotUtil.next("data", {
                    logoutModal: this.logoutModal,
                    scrutiny: this.scrutiny,
                    initFlg: this.initFlg,
                    title: "GPS端末一覧",
                    name: 'user_asset',
                    items: ["端末ID", "端末名", "パスワード", "利用者名", "利用開始日", "利用終了日", "端末状態", "連絡用メール", "発送先名", "電話番号", "住所", "注文番号", "備考", "機種",
                        "IMEI", "IMSI", "SIMID", "グループID", "アラート種類", "アラートメール", "更新日時",  "バージョン", "発信間隔パターン", "個別メッセージ", "発信間隔タイマー時刻",
                         "削除予定日", ],
                    service: new AssetService(),
                    disabledColumns: [2,7,8,14,15,16,17,18,22],
                    ajax: async function (handler) {
                        const param = {
                            email: UserInfo.getInstance().getEmail(),
                        }
                        const response = await this.service.search(param)
                        if (response.status != "OK" || !response.data || response.data.length < 1) {
                            return handler([])
                        }
                        let jsons = []
                        response.data.forEach(data => {
                            const json = {
                                assetId: this.scrutiny(data.assetId),
                                assetName: data.assetName ? trim(data.assetName) : '',
                                password: this.scrutiny(data.password),
                                groupId: this.scrutiny(data.groupId),
                                kindType: this.scrutiny(data.kindType),
                                imei: this.scrutiny(data.imei),
                                imsi: this.scrutiny(data.imsi),
                                userName: this.scrutiny(data.userName),
                                start: this.scrutiny(data.start),
                                end: this.scrutiny(data.end),
                                shipName:  this.scrutiny(data.shipName),
                                memo: this.scrutiny(data.memo),
                                alertType: this.scrutiny(data.alertType),
                                alertEmail: this.scrutiny(data.alertEmail),
                                contactEmail: this.scrutiny(data.contactEmail),
                                contactTel: this.scrutiny(data.contactTel),
                                contactAddress: this.scrutiny(data.contactAddress),
                                orderNo: this.scrutiny(data.orderNo),
                                pro: this.scrutiny(data.pro),
                                sendOpt: this.scrutiny(data.sendOpt),
                                message: this.scrutiny(data.message),
                                sendTimeOut: this.scrutiny(data.sendTimeOut),
                                simId: this.scrutiny(data.simId),
                                updatedAt: data.updatedAt ? data.updatedAt : '',
                                status: this.scrutiny(data.status),
                                unixTime: this.scrutiny(data.unixTime),
                                rowId: data.rowId ? data.rowId : Math.random()
                            }
                            jsons.push(json)
                        })
                        handler(jsons)
                    },
                    preSubmit: function (e, json, action, self) {

                        if (action == 'remove') return

                        const password = self.field('password')
                        if (!v8n().not.null().not.empty().test(password.get())) {
                            password.error('パスワードは必須です')
                        }

                        const imei = self.field('imei')
                        if (!v8n().not.null().not.empty().test(imei.get())) {
                            imei.error('IMEIは必須です')
                        }

                        const start = self.field('start')
                        const startValue = start.get()
                        const end = self.field('end')
                        const endValue = end.get()

                        const target = json.data[_.keys(json.data)[0]]

                        const oldStart = localStorage.getItem('user_asset_oldStart')

                        if (startValue && (oldStart != startValue)) {
                            // 利用終了日が空の場合
                            if (!endValue) {
                                // 昨日、本日、明日のみ有効
                                if (moment().hours(0).minutes(0).seconds(0).diff(moment(startValue).hours(0).minutes(0).seconds(0), 'days') < 0 || moment().hours(0).minutes(0).seconds(0).diff(moment(startValue).hours(0).minutes(0).seconds(0), 'days') > 1) {
                                    start.error('利用開始日に昨日～明日の範囲でご指定ください')
                                } else {
                                    target.end = moment(startValue).add(1, 'months').format('YYYY-MM-DD')
                                }
                            }
                        }

                        const assetName = self.field('assetName')
                        if (!v8n().not.null().not.empty().test(assetName.get())) {
                            target.assetName = " "
                        }

                        if (target.alertEmail) {
                            target.alertEmail = target.alertEmail.split('\n').join(',')
                        }

                        if (self.inError()) {
                            return false
                        }
                    },
                    addJSON: function (json) {
                        const alertTypeRender = function (data, type, row) {
                            if (!data) return ''
                            const alertTypes = Code.ALERT_TYPE.filter(code => {
                                return data.indexOf(code.value) > -1
                            })
                            const alerts = []
                            alertTypes.forEach(alertType => {
                                alerts.push(alertType.label)
                            })
                            return alerts.join(",")
                        }

                        json.columns.forEach(function (column) {
                            if (column.data == 'alertType') {
                                column.render = alertTypeRender
                            }
                            if (column.data == 'alertEmail') {
                                column.render = function (data, type, row) {
                                    if (data && data.indexOf(',') != -1) {
                                        data = data.split(',').join('<br>')
                                    }
                                    return data
                                }
                            }
                            if (column.data == 'status') {
                                column.render = function (data, type, row) {
                                    const code = Code.ASSET_STATUS.filter(code => {
                                        return code.value == data
                                    })[0]
                                    return code.label
                                }
                            }
                        })
                        return json
                    },
                    open: function (e, json, action, editor) {

                        if (action == 'edit') {
                            editor.field('assetId').disable()
                            editor.field('imei').disable()
                        } else {
                            editor.field('assetId').enable()
                            editor.field('imei').enable()
                        }

                        const alertEmail = editor.field('alertEmail').get()
                        if (alertEmail) {
                            editor.field('alertEmail').set(alertEmail.split(',').join('\n'))
                        }

                        $("input:checkbox").css("width", "20px")

                        const oldStart = editor.field('start').get()
                        localStorage.setItem('user_asset_oldStart', oldStart)
                    },
                    submitSuccess: async function (e, json, data) {

                        const api = $('#user_asset_datatables').dataTable().api()

                        const oldStart = localStorage.getItem('user_asset_oldStart')
                        // 利用開始日を入力したら端末状態を使用中にする
                        const start = data.start
                        const status = data.status
                        if (start && start != oldStart && !status) {
                            const assetService = new AssetService()
                            const r = await assetService.get(data.assetId)
                            if (r.statusCode == 200) {
                                data.updatedAt = r.data[0].updatedAt
                                data.status = 1
                                await assetService.update(data)
                            }

                        }
                        localStorage.removeItem('user_asset_oldStart')
                        api.ajax.reload()
                    },
                    actionButtons: [{
                        text: "解約予定",
                        func: async function (e, dt, editor, self, logoutModal, scrutiny) {
                            const data = dt.rows('.selected').data()
                            if (!data || data.length < 1) {
                                toastr.warning('解約予定の端末を選択してください')
                                return
                            }
                            if (data.length > 1) {
                                toastr.warning('解約予定の端末を1件選択してください')
                                return
                            }

                            const end = data[0].end
                            if (end) {
                                toastr.warning('利用終了日が登録されています')
                                return
                            }

                            riot.unmount('commonmodal', {}, 'userassetsuspend')
                            const userSuspendModal = riot.mount('commonmodal',{
                                data: data[0],
                                editor,
                            }, 'userassetsuspend')[0]
                            userSuspendModal.show()
                        }
                    }],
                }, "datatables")
            }
        }

        function trim(data) {
            if (data == ' ') {
                return ''
            }
            return data
        }

        function clearErrorMessage() {
            $("#error-message").text('').addClass('hide')
        }

        function setErrorMessage(message) {
            $("#error-message").text(message).removeClass('hide')
        }

    </script>
</user_asset>
